# Mac/OSX script


#!/bin/sh

export GROOT=$HOME/opt/GNAT/2018/bin
export PATH=$GROOT:$PATH

export FWROOT=/System/Library/Frameworks
export SDKROOT=$(xcrun --show-sdk-path)


$GROOT/gnatmake asudx -o osudx \
-O3 -gnat12 \
-D obj \
-I../src \
-I../src/adautils \
-I../src/adabindings/gl \
-I../src/adabindings/glfwada \
-I../src/adabindings/AdaPngLib \
-largs \
$PWD/../libs/osx/libglfw3.a \
\
-L$SDKROOT/usr/lib \
-lm -lz  -lstdc++ \
\
-F$FWROOT \
-framework OpenGL \
-framework ForceFeedback \
-framework CoreFoundation \
-framework Carbon \
-framework Cocoa \
-framework QuartzCore \
-framework IOKit \
-framework Metal \
-pthread 

mv osudx  ..



# -- Copyright (C) 2024  <fastrgv@gmail.com>
# --
# -- This program is free software: you can redistribute it and/or modify
# -- it under the terms of the GNU General Public License as published by
# -- the Free Software Foundation, either version 3 of the License, or
# -- (at your option) any later version.
# --
# -- This program is distributed in the hope that it will be useful,
# -- but WITHOUT ANY WARRANTY; without even the implied warranty of
# -- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# -- GNU General Public License for more details.
# --
# -- You may read the full text of the GNU General Public License
# -- at <http://www.gnu.org/licenses/>.

